/**
 * MIT License
 *
 * Copyright (c) 2019 Xu Liangzhan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */
import { hooks } from '@xmweb-ui/vue-common';
declare const _default: hooks.DefineComponent<{
    align: StringConstructor;
    className: (StringConstructor | FunctionConstructor)[];
    editor: (ObjectConstructor | FunctionConstructor)[];
    field: StringConstructor;
    filter: {};
    filterMethod: FunctionConstructor;
    filterMultiple: {
        type: BooleanConstructor;
        default: boolean;
    };
    filterRender: ObjectConstructor;
    filters: ArrayConstructor;
    fixed: StringConstructor;
    footerAlign: StringConstructor;
    footerClassName: (StringConstructor | FunctionConstructor)[];
    formatConfig: {
        type: ObjectConstructor;
        default: () => {
            data: never[];
        };
    };
    formatText: (StringConstructor | FunctionConstructor)[];
    formatValue: FunctionConstructor;
    group: {
        type: BooleanConstructor;
        default: boolean;
    };
    headerAlign: StringConstructor;
    headerClassName: (StringConstructor | FunctionConstructor)[];
    indexMethod: FunctionConstructor;
    label: StringConstructor;
    minWidth: (StringConstructor | NumberConstructor)[];
    params: ObjectConstructor;
    prop: StringConstructor;
    remoteSort: {
        type: BooleanConstructor;
        default: null;
    };
    renderer: (ObjectConstructor | FunctionConstructor)[];
    required: {
        type: BooleanConstructor;
        default: boolean;
    };
    resizable: {
        type: BooleanConstructor;
        default: null;
    };
    rules: ObjectConstructor;
    showHeaderOverflow: {
        type: (StringConstructor | BooleanConstructor)[];
        default: null;
    };
    showHeaderTip: {
        type: BooleanConstructor;
        default: null;
    };
    showIcon: {
        type: BooleanConstructor;
        default: boolean;
    };
    showOverflow: {
        type: (StringConstructor | BooleanConstructor)[];
        default: null;
    };
    showTip: {
        type: BooleanConstructor;
        default: null;
    };
    sortBy: (StringConstructor | ArrayConstructor)[];
    sortMethod: FunctionConstructor;
    sortable: {
        type: BooleanConstructor;
        default: boolean;
    };
    title: (StringConstructor | FunctionConstructor)[];
    treeNode: BooleanConstructor;
    type: StringConstructor;
    width: (StringConstructor | NumberConstructor)[];
    operationConfig: ObjectConstructor;
    xm_mode: StringConstructor;
    xm_mode_root: BooleanConstructor;
    xm_template: (ObjectConstructor | FunctionConstructor)[];
    xm_renderless: FunctionConstructor;
    xm_theme: StringConstructor;
    xm_chart_theme: ObjectConstructor;
}, {
    columnConfig: any;
    slots: Readonly<{
        [name: string]: hooks.Slot<any> | undefined;
    }>;
    cacheKey: hooks.Raw<{
        uid: number;
    }>;
    firstRow: any;
}, unknown, {}, {
    createColumn($table: any, colProps: any): any;
    renderHeader(h: any, params: any): any;
    renderCell(h: any, params: any): any;
    renderTreeCell(h: any, params: any): any[];
    renderTreeIcon(h: any, params: any): any[];
    renderIndexHeader(h: any, params: any): any;
    renderTreeIndexCell(h: any, params: any): any[];
    renderIndexCell(h: any, params: any): any;
    renderRadioHeader(h: any, params: any): any;
    renderRadioCell(h: any, params: any): any;
    renderTreeRadioCell(h: any, params: any): any[];
    renderSelectionHeader(h: any, params: any): any;
    renderSelectionCell(h: any, params: any): any;
    renderTreeSelectionCell(h: any, params: any): any[];
    renderSelectionCellByProp(h: any, params: any): any;
    renderTreeSelectionCellByProp(h: any, params: any): any[];
    renderExpandCell(h: any, params: any): any[] | null;
    renderExpandData(h: any, params: any): any;
    renderSortAndFilterHeader(h: any, params: any): any;
    renderSortHeader(h: any, params: any): any;
    renderSortIcon(h: any, params: any): any[];
    renderFilterHeader(h: any, params: any): any;
    renderFilterIcon(h: any, params: any, cls?: string): any[];
    renderEditHeader(h: any, params: any): any[];
    renderTreeRowEdit(h: any, params: any): any[];
    renderRowEdit(h: any, params: any): any;
    renderTreeCellEdit(h: any, params: any): any[];
    renderCellEdit(h: any, params: any): any;
    runRenderer(h: any, params: any, _vm: any, isEdit: any): any;
    getSuffixCls(params: any): string[];
    renderOperationCell(h: any, params: any): any;
}, hooks.ComponentOptionsMixin, hooks.ComponentOptionsMixin, {}, string, hooks.VNodeProps & hooks.AllowedComponentProps & hooks.ComponentCustomProps, Readonly<hooks.ExtractPropTypes<{
    align: StringConstructor;
    className: (StringConstructor | FunctionConstructor)[];
    editor: (ObjectConstructor | FunctionConstructor)[];
    field: StringConstructor;
    filter: {};
    filterMethod: FunctionConstructor;
    filterMultiple: {
        type: BooleanConstructor;
        default: boolean;
    };
    filterRender: ObjectConstructor;
    filters: ArrayConstructor;
    fixed: StringConstructor;
    footerAlign: StringConstructor;
    footerClassName: (StringConstructor | FunctionConstructor)[];
    formatConfig: {
        type: ObjectConstructor;
        default: () => {
            data: never[];
        };
    };
    formatText: (StringConstructor | FunctionConstructor)[];
    formatValue: FunctionConstructor;
    group: {
        type: BooleanConstructor;
        default: boolean;
    };
    headerAlign: StringConstructor;
    headerClassName: (StringConstructor | FunctionConstructor)[];
    indexMethod: FunctionConstructor;
    label: StringConstructor;
    minWidth: (StringConstructor | NumberConstructor)[];
    params: ObjectConstructor;
    prop: StringConstructor;
    remoteSort: {
        type: BooleanConstructor;
        default: null;
    };
    renderer: (ObjectConstructor | FunctionConstructor)[];
    required: {
        type: BooleanConstructor;
        default: boolean;
    };
    resizable: {
        type: BooleanConstructor;
        default: null;
    };
    rules: ObjectConstructor;
    showHeaderOverflow: {
        type: (StringConstructor | BooleanConstructor)[];
        default: null;
    };
    showHeaderTip: {
        type: BooleanConstructor;
        default: null;
    };
    showIcon: {
        type: BooleanConstructor;
        default: boolean;
    };
    showOverflow: {
        type: (StringConstructor | BooleanConstructor)[];
        default: null;
    };
    showTip: {
        type: BooleanConstructor;
        default: null;
    };
    sortBy: (StringConstructor | ArrayConstructor)[];
    sortMethod: FunctionConstructor;
    sortable: {
        type: BooleanConstructor;
        default: boolean;
    };
    title: (StringConstructor | FunctionConstructor)[];
    treeNode: BooleanConstructor;
    type: StringConstructor;
    width: (StringConstructor | NumberConstructor)[];
    operationConfig: ObjectConstructor;
    xm_mode: StringConstructor;
    xm_mode_root: BooleanConstructor;
    xm_template: (ObjectConstructor | FunctionConstructor)[];
    xm_renderless: FunctionConstructor;
    xm_theme: StringConstructor;
    xm_chart_theme: ObjectConstructor;
}>>, {
    required: boolean;
    xm_mode_root: boolean;
    showIcon: boolean;
    group: boolean;
    formatConfig: Record<string, any>;
    showHeaderTip: boolean;
    resizable: boolean;
    showHeaderOverflow: string | boolean;
    showOverflow: string | boolean;
    showTip: boolean;
    treeNode: boolean;
    sortable: boolean;
    remoteSort: boolean;
    filterMultiple: boolean;
}, {}>;
export default _default;
